package monads;

import java.util.function.Function;

public interface Monad<T> {
    static <U> Monad<U> unit(U value) {
        return null;
    }
    <U> Monad<U> flatMap(Function<T, Monad<U>> mapper);
    default <U> Monad<U> map(Function<T, U> mapper) {
        return flatMap(t -> unit(mapper.apply(t)));
    }
}
