package monads;

public class ResultExamples {
    public static void main(String[] args) {
//        var ok = Result.ok();
    }

    private static class Result<T> {
        private final T value;
        private final String error;

        private Result(T value, String error) {
            this.value = value;
            this.error = error;
        }

        public static <U> Result<U> ok(U value) {
            return new Result<>(value, null);
        }

        public static <U> Result<U> error(String error) {
            return new Result<>(null, error);
        }

        public boolean isError() {
            return error != null;
        }

        public String getError() {
            return error;
        }

        public T getValue() {
            return value;
        }
    }
}
