package monads.util;

import java.util.Optional;
import java.util.function.BiFunction;

public final class OptionalUtils {
    @SuppressWarnings("OptionalUsedAsFieldOrParameterType")
    public static Optional<Integer> optionalAdd(Optional<Integer> val1, Optional<Integer> val2) {
        return flatMap2(val1, val2, (first, second) -> Optional.of(first + second));
    }

    @SuppressWarnings("OptionalUsedAsFieldOrParameterType")
    public static <T, U, R> Optional<R> flatMap2(
            Optional<T> opt1,
            Optional<U> opt2,
            BiFunction<T, U, Optional<R>> mapper
    ) {
        return opt1.flatMap(a ->
                opt2.flatMap(b ->
                        mapper.apply(a, b)
                ));
    }
}
